(function($dvt$$16$$) {
  function $DvtTagCloudKeyboardHandler$$($dvt$$16$$) {
    this.Init($dvt$$16$$);
  }
  function $DvtTagCloudEventManager$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    this.Init($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$);
    this.$_view$ = $dvt$$16$$;
  }
  function $DvtTagCloudLayoutUtils$$() {
  }
  function $DvtTagCloudDefaults$$() {
    this.Init({alta:$DvtTagCloudDefaults$$.$VERSION_1$});
  }
  function $DvtTagCloudObjPeer$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    this.Init($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$);
  }
  function $DvtTagCloudItem$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$, $DvtTagCloudDefaults$$, $DvtTagCloudRenderer$$, $DvtTagCloudObjPeer$$, $styleClass$$13$$, $id$$198$$) {
    this.Init($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$, $DvtTagCloudDefaults$$, $DvtTagCloudRenderer$$, $DvtTagCloudObjPeer$$, $styleClass$$13$$, $id$$198$$);
  }
  function $DvtTagCloudAutomation$$($dvt$$16$$) {
    this.$_tagCloud$ = $dvt$$16$$;
  }
  $dvt$$16$$.$TagCloud$ = function $$dvt$$16$$$$TagCloud$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    this.Init($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$);
  };
  $dvt$$16$$.$Obj$.$createSubclass$($dvt$$16$$.$TagCloud$, $dvt$$16$$.$BaseComponent$);
  $dvt$$16$$.$TagCloud$.newInstance = function $$dvt$$16$$$$TagCloud$$newInstance$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    return new $dvt$$16$$.$TagCloud$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.Init = function $$dvt$$16$$$$TagCloud$$$Init$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    $dvt$$16$$.$TagCloud$.$superclass$.Init.call(this, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$);
    this.$getCtx$().$_stage$.$getElem$().setAttributeNS(null, "text-rendering", "geometricPrecision");
    this.$EventManager$ = new $DvtTagCloudEventManager$$(this, $DvtTagCloudAutomation$$, this.$processEvent$, this);
    this.$EventManager$.$addListeners$(this);
    $dvt$$16$$.$Agent$.$isTouchDevice$() || this.$EventManager$.$setKeyboardHandler$(new $DvtTagCloudKeyboardHandler$$(this.$EventManager$));
    this.$Defaults$ = new $DvtTagCloudDefaults$$;
    this.$_items$ = [];
    this.$_peers$ = [];
    this.$legend$ = null;
    this.$_dragSource$ = new $dvt$$16$$.$DragSource$(this.$getCtx$());
    this.$EventManager$.$setDragSource$(this.$_dragSource$);
  };
  $dvt$$16$$.$TagCloud$.prototype.$render$ = function $$dvt$$16$$$$TagCloud$$$$render$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    isNaN($DvtTagCloudStyleUtils$$) || isNaN($DvtTagCloudItem$$) || (this.$Width$ = $DvtTagCloudStyleUtils$$, this.$Height$ = $DvtTagCloudItem$$);
    this.$__cleanUp$();
    this.$SetOptions$($DvtTagCloudAutomation$$);
    this.$StopAnimation$();
    this.$_oldContainer$ = this.$_container$;
    this.$_oldItems$ = this.$_items$;
    this.$_items$ = [];
    this.$_itemCollection$ = [];
    this.$_container$ = new $dvt$$16$$.$Container$(this.$getCtx$());
    this.$addChild$(this.$_container$);
    $DvtTagCloudRenderer$$.$render$(this, this.$_container$, new $dvt$$16$$.$Rectangle$(0, 0, this.$Width$, this.$Height$));
    this.$SelectionHandler$ && this.$SelectionHandler$.$processInitialSelections$(this.$Options$.selection, this.$getObjects$());
    $DvtTagCloudStyleUtils$$ = this.$Options$.animationDuration;
    $DvtTagCloudItem$$ = new $dvt$$16$$.$Rectangle$(0, 0, this.$Width$, this.$Height$);
    this.$_oldContainer$ ? "none" !== this.$Options$.animationOnDataChange && $DvtTagCloudAutomation$$ && (this.$_deleteContainer$ = new $dvt$$16$$.$Container$(this.$getCtx$()), this.$addChild$(this.$_deleteContainer$), $DvtTagCloudAutomation$$ = new $dvt$$16$$.$DataAnimationHandler$(this.$getCtx$(), this.$_deleteContainer$), $DvtTagCloudAutomation$$.$constructAnimation$(this.$_oldItems$, this.$_items$), this.$Animation$ = $DvtTagCloudAutomation$$.$getAnimation$()) : "none" !== this.$Options$.animationOnDisplay && 
    (this.$Animation$ = $dvt$$16$$.$BlackBoxAnimationHandler$.$getInAnimation$(this.$getCtx$(), $dvt$$16$$.$BlackBoxAnimationHandler$.$ALPHA_FADE$, this.$_container$, $DvtTagCloudItem$$, $DvtTagCloudStyleUtils$$));
    this.$Animation$ ? (this.$EventManager$.$hideTooltip$(), this.$EventManager$.$removeListeners$(this), this.$Animation$.$setOnEnd$(this.$OnRenderEnd$, this), this.$Animation$.play()) : this.$OnRenderEnd$();
    this.$UpdateAriaAttributes$();
  };
  $dvt$$16$$.$TagCloud$.prototype.$registerItems$ = function $$dvt$$16$$$$TagCloud$$$$registerItems$$($dvt$$16$$) {
    this.$_items$ = $dvt$$16$$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$getAutomation$ = function $$dvt$$16$$$$TagCloud$$$$getAutomation$$() {
    this.$Automation$ || (this.$Automation$ = new $DvtTagCloudAutomation$$(this));
    return this.$Automation$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$registerObject$ = function $$dvt$$16$$$$TagCloud$$$$registerObject$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    this.$_peers$.push($dvt$$16$$);
    this.$_itemCollection$[$DvtTagCloudAutomation$$] = $dvt$$16$$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$getObjects$ = function $$dvt$$16$$$$TagCloud$$$$getObjects$$() {
    return this.$_peers$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$getItems$ = function $$dvt$$16$$$$TagCloud$$$$getItems$$() {
    return this.$_itemCollection$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$highlight$ = function $$dvt$$16$$$$TagCloud$$$$highlight$$($DvtTagCloudAutomation$$) {
    this.$Options$.highlightedCategories = $dvt$$16$$.$JsonUtils$.clone($DvtTagCloudAutomation$$);
    $dvt$$16$$.$CategoryRolloverHandler$.$highlight$($DvtTagCloudAutomation$$, this.$getObjects$(), "any" === this.$Options$.highlightMatch);
    this.$legend$ && this.$legend$.$highlight$($DvtTagCloudAutomation$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.select = function $$dvt$$16$$$$TagCloud$$$select$($DvtTagCloudAutomation$$) {
    this.$Options$.selection = $dvt$$16$$.$JsonUtils$.clone($DvtTagCloudAutomation$$);
    this.$SelectionHandler$ && this.$SelectionHandler$.$processInitialSelections$(this.$Options$.selection, this.$getObjects$());
  };
  $dvt$$16$$.$TagCloud$.prototype.$SetOptions$ = function $$dvt$$16$$$$TagCloud$$$$SetOptions$$($DvtTagCloudAutomation$$) {
    $DvtTagCloudAutomation$$ ? this.$Options$ = this.$Defaults$.$calcOptions$($DvtTagCloudAutomation$$) : this.$Options$ || (this.$Options$ = this.$GetDefaults$());
    $DvtTagCloudAutomation$$ = this.$Options$.selectionMode;
    this.$SelectionHandler$ = "single" === $DvtTagCloudAutomation$$ ? new $dvt$$16$$.$SelectionHandler$($dvt$$16$$.$SelectionHandler$.$TYPE_SINGLE$) : "multiple" === $DvtTagCloudAutomation$$ ? new $dvt$$16$$.$SelectionHandler$($dvt$$16$$.$SelectionHandler$.$TYPE_MULTIPLE$) : null;
    this.$EventManager$.$setSelectionHandler$(this.$SelectionHandler$);
    $dvt$$16$$.$Agent$.$isEnvironmentBrowser$() || (this.$Options$.animationOnDisplay = "none", this.$Options$.animationOnDataChange = "none");
  };
  $dvt$$16$$.$TagCloud$.prototype.$GetComponentDescription$ = function $$dvt$$16$$$$TagCloud$$$$GetComponentDescription$$() {
    return $dvt$$16$$.$Bundle$.$getTranslation$(this.$getOptions$(), "componentName", $dvt$$16$$.$Bundle$.$UTIL_PREFIX$, "TAG_CLOUD");
  };
  $dvt$$16$$.$TagCloud$.prototype.$OnRenderEnd$ = function $$dvt$$16$$$$TagCloud$$$$OnRenderEnd$$() {
    this.$_oldContainer$ && (this.removeChild(this.$_oldContainer$), this.$_oldContainer$.$destroy$(), this.$_oldContainer$ = null);
    this.$_deleteContainer$ && (this.removeChild(this.$_deleteContainer$), this.$_deleteContainer$.$destroy$(), this.$_deleteContainer$ = null);
    this.$Animation$ && this.$EventManager$.$addListeners$(this);
    this.$Options$.highlightedCategories && 0 < this.$Options$.highlightedCategories.length && this.$highlight$(this.$Options$.highlightedCategories);
    this.$AnimationStopped$ || this.$RenderComplete$();
    this.$Animation$ = null;
    this.$AnimationStopped$ = !1;
  };
  $dvt$$16$$.$TagCloud$.prototype.$__cleanUp$ = function $$dvt$$16$$$$TagCloud$$$$__cleanUp$$() {
    this.$EventManager$.$hideTooltip$();
    this.$_peers$.length = 0;
  };
  $dvt$$16$$.$TagCloud$.prototype.$processEvent$ = function $$dvt$$16$$$$TagCloud$$$$processEvent$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    var $DvtTagCloudItem$$ = $DvtTagCloudAutomation$$.type;
    if ("categoryHide" == $DvtTagCloudItem$$ || "categoryShow" == $DvtTagCloudItem$$) {
      var $DvtTagCloudDefaults$$ = $DvtTagCloudAutomation$$.category, $DvtTagCloudRenderer$$ = $dvt$$16$$.$ArrayUtils$.$getIndex$(this.$Options$.hiddenCategories, $DvtTagCloudDefaults$$);
      "categoryHide" == $DvtTagCloudItem$$ && 0 > $DvtTagCloudRenderer$$ && this.$Options$.hiddenCategories.push($DvtTagCloudDefaults$$);
      "categoryShow" == $DvtTagCloudItem$$ && 0 <= $DvtTagCloudRenderer$$ && this.$Options$.hiddenCategories.splice($DvtTagCloudRenderer$$, 1);
      this.$render$(this.$Options$, this.$Width$, this.$Height$);
    } else {
      "categoryHighlight" == $DvtTagCloudItem$$ && (this != $DvtTagCloudStyleUtils$$ ? this.$highlight$($DvtTagCloudAutomation$$.categories) : this.$legend$ && this.$legend$ != $DvtTagCloudStyleUtils$$ && this.$legend$.$processEvent$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$));
    }
    $DvtTagCloudAutomation$$ && this.dispatchEvent($DvtTagCloudAutomation$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.$isDragSupported$ = function $$dvt$$16$$$$TagCloud$$$$isDragSupported$$($dvt$$16$$) {
    return this.$SelectionHandler$ ? $dvt$$16$$[0] : null;
  };
  $dvt$$16$$.$TagCloud$.prototype.$getDragRowKeys$ = function $$dvt$$16$$$$TagCloud$$$$getDragRowKeys$$($dvt$$16$$) {
    $dvt$$16$$.$isSelected$() || (this.$SelectionHandler$.$processClick$($dvt$$16$$, !1), this.$EventManager$.$fireSelectionEvent$());
    $dvt$$16$$ = [];
    for (var $DvtTagCloudAutomation$$ = this.$SelectionHandler$.getSelection(), $DvtTagCloudStyleUtils$$ = 0;$DvtTagCloudStyleUtils$$ < $DvtTagCloudAutomation$$.length;$DvtTagCloudStyleUtils$$++) {
      var $DvtTagCloudItem$$ = $DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$];
      $DvtTagCloudItem$$ instanceof $DvtTagCloudObjPeer$$ && $dvt$$16$$.push($DvtTagCloudItem$$.getId());
    }
    return $dvt$$16$$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$getDragFeedback$ = function $$dvt$$16$$$$TagCloud$$$$getDragFeedback$$() {
    for (var $dvt$$16$$ = [], $DvtTagCloudAutomation$$ = this.$SelectionHandler$.getSelection(), $DvtTagCloudStyleUtils$$ = 0;$DvtTagCloudStyleUtils$$ < $DvtTagCloudAutomation$$.length;$DvtTagCloudStyleUtils$$++) {
      $dvt$$16$$ = $dvt$$16$$.concat($DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$].$getDisplayables$());
    }
    return $dvt$$16$$;
  };
  $dvt$$16$$.$TagCloud$.prototype.$isDragAvailable$ = function $$dvt$$16$$$$TagCloud$$$$isDragAvailable$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    return this.$_dragSource$.$isDragAvailable$($DvtTagCloudStyleUtils$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.$getDragTransferable$ = function $$dvt$$16$$$$TagCloud$$$$getDragTransferable$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    return this.$_dragSource$.$getDragTransferable$($dvt$$16$$, $DvtTagCloudAutomation$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.$getDragOverFeedback$ = function $$dvt$$16$$$$TagCloud$$$$getDragOverFeedback$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    return this.$_dragSource$.$getDragOverFeedback$($dvt$$16$$, $DvtTagCloudAutomation$$);
  };
  $dvt$$16$$.$TagCloud$.prototype.$getDragOffset$ = function $$dvt$$16$$$$TagCloud$$$$getDragOffset$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    return this.$_dragSource$.$getDragOffset$($dvt$$16$$, $DvtTagCloudAutomation$$);
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudAutomation$$, $dvt$$16$$.$Automation$);
  $DvtTagCloudAutomation$$.prototype.$GetSubIdForDomElement$ = function $$DvtTagCloudAutomation$$$$$GetSubIdForDomElement$$($dvt$$16$$) {
    return ($dvt$$16$$ = this.$_tagCloud$.$EventManager$.$GetLogicalObject$($dvt$$16$$)) && $dvt$$16$$ instanceof $DvtTagCloudObjPeer$$ ? "item[" + this.$_tagCloud$.$getItems$().indexOf($dvt$$16$$) + "]" : null;
  };
  $DvtTagCloudAutomation$$.prototype.$getDomElementForSubId$ = function $$DvtTagCloudAutomation$$$$$getDomElementForSubId$$($DvtTagCloudAutomation$$) {
    if ($DvtTagCloudAutomation$$ == $dvt$$16$$.$Automation$.$TOOLTIP_SUBID$) {
      return this.$GetTooltipElement$(this.$_tagCloud$);
    }
    var $DvtTagCloudStyleUtils$$ = $DvtTagCloudAutomation$$.indexOf("[");
    return 0 < $DvtTagCloudStyleUtils$$ && "item" === $DvtTagCloudAutomation$$.substring(0, $DvtTagCloudStyleUtils$$) && ($DvtTagCloudAutomation$$ = parseInt($DvtTagCloudAutomation$$.substring($DvtTagCloudStyleUtils$$ + 1, $DvtTagCloudAutomation$$.length - 1)), $DvtTagCloudAutomation$$ = this.$_tagCloud$.$getItems$()[$DvtTagCloudAutomation$$]) ? $DvtTagCloudAutomation$$.$getDisplayables$()[0].$getElem$() : null;
  };
  $DvtTagCloudAutomation$$.prototype.getItem = function $$DvtTagCloudAutomation$$$$getItem$($dvt$$16$$) {
    if ($dvt$$16$$ = this.$_tagCloud$.$getItems$()[$dvt$$16$$]) {
      var $DvtTagCloudAutomation$$ = {};
      $DvtTagCloudAutomation$$.color = $dvt$$16$$.$getDatatipColor$();
      $DvtTagCloudAutomation$$.tooltip = $dvt$$16$$.$getShortDesc$();
      $DvtTagCloudAutomation$$.label = $dvt$$16$$.$getLabel$();
      $DvtTagCloudAutomation$$.value = $dvt$$16$$.getValue();
      $DvtTagCloudAutomation$$.selected = $dvt$$16$$.$isSelected$();
      return $DvtTagCloudAutomation$$;
    }
    return null;
  };
  $DvtTagCloudAutomation$$.prototype.$getItemCount$ = function $$DvtTagCloudAutomation$$$$$getItemCount$$() {
    return this.$_tagCloud$.$getObjects$().length;
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudItem$$, $dvt$$16$$.$BackgroundOutputText$);
  $DvtTagCloudItem$$.$_HOVER_OPACITY$ = .3;
  $DvtTagCloudItem$$.$_HOVER_SELECTED_OPACITY$ = .6;
  $DvtTagCloudItem$$.$ANIMATION_DELETE_PRIORITY$ = 0;
  $DvtTagCloudItem$$.$ANIMATION_UPDATE_PRIORITY$ = 1;
  $DvtTagCloudItem$$.$ANIMATION_INSERT_PRIORITY$ = 2;
  $DvtTagCloudItem$$.prototype.Init = function $$DvtTagCloudItem$$$$Init$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudDefaults$$, $DvtTagCloudRenderer$$, $DvtTagCloudObjPeer$$, $itemStyle$$1$$, $styleClass$$14$$, $id$$199$$) {
    $DvtTagCloudItem$$.$superclass$.Init.call(this, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudDefaults$$, $DvtTagCloudRenderer$$, $DvtTagCloudObjPeer$$, $id$$199$$);
    this.$_tagCloud$ = $dvt$$16$$;
    this.$alignAuto$();
    this.$TextInstance$.$setStyle$($itemStyle$$1$$);
    this.$TextInstance$.$setClassName$($styleClass$$14$$);
    $DvtTagCloudObjPeer$$ && this.$_createFeedbackStyles$($DvtTagCloudObjPeer$$);
  };
  $DvtTagCloudItem$$.prototype.$setSelected$ = function $$DvtTagCloudItem$$$$$setSelected$$($dvt$$16$$) {
    this.$_isSelected$ != $dvt$$16$$ && ((this.$_isSelected$ = $dvt$$16$$) ? this.$_isShowingHoverEffect$ ? this.$setCSSStyle$(this.$_hoverSelectedStyle$) : this.$setCSSStyle$(this.$_selectedStyle$) : this.$setCSSStyle$(this.$_normalStyle$));
  };
  $DvtTagCloudItem$$.prototype.$showHoverEffect$ = function $$DvtTagCloudItem$$$$$showHoverEffect$$() {
    this.$_isShowingHoverEffect$ || (this.$_isShowingHoverEffect$ = !0, this.$_isSelected$ ? this.$setCSSStyle$(this.$_hoverSelectedStyle$) : this.$setCSSStyle$(this.$_hoverStyle$));
  };
  $DvtTagCloudItem$$.prototype.$hideHoverEffect$ = function $$DvtTagCloudItem$$$$$hideHoverEffect$$() {
    this.$_isSelected$ ? this.$setCSSStyle$(this.$_selectedStyle$) : this.$setCSSStyle$(this.$_normalStyle$);
    this.$_isShowingHoverEffect$ = !1;
  };
  $DvtTagCloudItem$$.prototype.$animateUpdate$ = function $$DvtTagCloudItem$$$$$animateUpdate$$($DvtTagCloudAutomation$$, $DvtTagCloudDefaults$$) {
    var $DvtTagCloudRenderer$$ = new $dvt$$16$$.$CustomAnimation$(this.$getCtx$(), this, $DvtTagCloudStyleUtils$$.$getAnimationDuration$(this.$_tagCloud$)), $DvtTagCloudObjPeer$$ = this.$getCSSStyle$(), $endX$$1_oldStyle_startSize$$ = $DvtTagCloudDefaults$$.$getCSSStyle$(), $bSizeChange_startY$$5$$ = !1, $startAlign_startColor$$14$$ = $endX$$1_oldStyle_startSize$$.$getStyle$($dvt$$16$$.$CSSStyle$.$COLOR$), $endAlign_endColor$$17$$ = $DvtTagCloudObjPeer$$.$getStyle$($dvt$$16$$.$CSSStyle$.$COLOR$);
    if ($startAlign_startColor$$14$$ != $endAlign_endColor$$17$$) {
      var $tag$$ = this;
      this.$setCSSStyle$($DvtTagCloudObjPeer$$.$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $startAlign_startColor$$14$$));
      $DvtTagCloudRenderer$$.$_animator$.$addProp$($dvt$$16$$.$Animator$.$TYPE_COLOR$, this, function() {
        return $tag$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$COLOR$);
      }, function($DvtTagCloudAutomation$$) {
        $tag$$.$setCSSStyle$($tag$$.$getCSSStyle$().$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $DvtTagCloudAutomation$$));
      }, $endAlign_endColor$$17$$);
    }
    $endX$$1_oldStyle_startSize$$ = parseFloat($endX$$1_oldStyle_startSize$$.$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$));
    $DvtTagCloudObjPeer$$ = parseFloat($DvtTagCloudObjPeer$$.$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$));
    $endX$$1_oldStyle_startSize$$ != $DvtTagCloudObjPeer$$ && ($bSizeChange_startY$$5$$ = !0, $tag$$ = this, this.$setFontSize$($endX$$1_oldStyle_startSize$$), $DvtTagCloudRenderer$$.$_animator$.$addProp$($dvt$$16$$.$Animator$.$TYPE_NUMBER$, this, function() {
      return parseFloat($tag$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$));
    }, this.$setFontSize$, $DvtTagCloudObjPeer$$));
    $DvtTagCloudObjPeer$$ = $DvtTagCloudDefaults$$.$getX$();
    $endX$$1_oldStyle_startSize$$ = this.$getX$();
    $startAlign_startColor$$14$$ = $DvtTagCloudDefaults$$.$getHorizAlignment$();
    $endAlign_endColor$$17$$ = this.$getHorizAlignment$();
    if ($endX$$1_oldStyle_startSize$$ != $DvtTagCloudObjPeer$$ || $bSizeChange_startY$$5$$ && $endAlign_endColor$$17$$ != $startAlign_startColor$$14$$) {
      $endAlign_endColor$$17$$ != $startAlign_startColor$$14$$ && ($DvtTagCloudObjPeer$$ = $DvtTagCloudItem$$.$_adjustX$($DvtTagCloudDefaults$$, $DvtTagCloudObjPeer$$, $startAlign_startColor$$14$$)), this.$setX$($DvtTagCloudObjPeer$$), $DvtTagCloudRenderer$$.$_animator$.$addProp$($dvt$$16$$.$Animator$.$TYPE_NUMBER$, this, this.$getX$, this.$setX$, $endX$$1_oldStyle_startSize$$);
    }
    $bSizeChange_startY$$5$$ = $DvtTagCloudDefaults$$.$getY$();
    $DvtTagCloudObjPeer$$ = this.$getY$();
    $DvtTagCloudObjPeer$$ != $bSizeChange_startY$$5$$ && (this.$setY$($bSizeChange_startY$$5$$), $DvtTagCloudRenderer$$.$_animator$.$addProp$($dvt$$16$$.$Animator$.$TYPE_NUMBER$, this, this.$getY$, this.$setY$, $DvtTagCloudObjPeer$$));
    $DvtTagCloudDefaults$$.$setAlpha$(0);
    $DvtTagCloudAutomation$$.add($DvtTagCloudRenderer$$, $DvtTagCloudItem$$.$ANIMATION_UPDATE_PRIORITY$);
  };
  $DvtTagCloudItem$$.prototype.$animateDelete$ = function $$DvtTagCloudItem$$$$$animateDelete$$($DvtTagCloudAutomation$$) {
    $DvtTagCloudAutomation$$.add(new $dvt$$16$$.$AnimFadeOut$(this.$getCtx$(), this, $DvtTagCloudStyleUtils$$.$getAnimationDuration$(this.$_tagCloud$)), $DvtTagCloudItem$$.$ANIMATION_DELETE_PRIORITY$);
  };
  $DvtTagCloudItem$$.prototype.$animateInsert$ = function $$DvtTagCloudItem$$$$$animateInsert$$($DvtTagCloudAutomation$$) {
    this.$setAlpha$(0);
    $DvtTagCloudAutomation$$.add(new $dvt$$16$$.$AnimFadeIn$(this.$getCtx$(), this, $DvtTagCloudStyleUtils$$.$getAnimationDuration$(this.$_tagCloud$)), $DvtTagCloudItem$$.$ANIMATION_INSERT_PRIORITY$);
  };
  $DvtTagCloudItem$$.prototype.$setFontSize$ = function $$DvtTagCloudItem$$$$$setFontSize$$($dvt$$16$$) {
    $DvtTagCloudItem$$.$superclass$.$setFontSize$.call(this, $dvt$$16$$);
    this.$_createFeedbackStyles$(this.$getCSSStyle$());
  };
  $DvtTagCloudItem$$.prototype.$_createFeedbackStyles$ = function $$DvtTagCloudItem$$$$$_createFeedbackStyles$$($DvtTagCloudAutomation$$) {
    this.$_normalStyle$ = $DvtTagCloudAutomation$$.clone();
    $DvtTagCloudAutomation$$ = this.$_normalStyle$.$getStyle$($dvt$$16$$.$CSSStyle$.$COLOR$);
    this.$_normalStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$BACKGROUND_COLOR$, null);
    this.$_hoverStyle$ = this.$_normalStyle$.clone();
    var $DvtTagCloudStyleUtils$$ = $DvtTagCloudItem$$.$_lightenColor$($DvtTagCloudAutomation$$, $DvtTagCloudItem$$.$_HOVER_OPACITY$);
    this.$_hoverStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$BACKGROUND_COLOR$, $DvtTagCloudStyleUtils$$);
    this.$_hoverStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $dvt$$16$$.$ColorUtils$.$getContrastingTextColor$($DvtTagCloudStyleUtils$$));
    this.$_selectedStyle$ = this.$_normalStyle$.clone();
    this.$_selectedStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$BACKGROUND_COLOR$, $DvtTagCloudAutomation$$);
    this.$_selectedStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $dvt$$16$$.$ColorUtils$.$getContrastingTextColor$($DvtTagCloudAutomation$$));
    this.$_hoverSelectedStyle$ = this.$_normalStyle$.clone();
    $DvtTagCloudAutomation$$ = $DvtTagCloudItem$$.$_lightenColor$($DvtTagCloudAutomation$$, $DvtTagCloudItem$$.$_HOVER_SELECTED_OPACITY$);
    this.$_hoverSelectedStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$BACKGROUND_COLOR$, $DvtTagCloudAutomation$$);
    this.$_hoverSelectedStyle$.$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $dvt$$16$$.$ColorUtils$.$getContrastingTextColor$($DvtTagCloudAutomation$$));
  };
  $DvtTagCloudItem$$.$_adjustX$ = function $$DvtTagCloudItem$$$$_adjustX$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    $DvtTagCloudAutomation$$ = $DvtTagCloudAutomation$$.$getTextDimensions$();
    return $DvtTagCloudItem$$ == $dvt$$16$$.$OutputText$.$H_ALIGN_LEFT$ ? $DvtTagCloudStyleUtils$$ + $DvtTagCloudAutomation$$.$w$ : $DvtTagCloudItem$$ == $dvt$$16$$.$OutputText$.$H_ALIGN_RIGHT$ ? $DvtTagCloudStyleUtils$$ - $DvtTagCloudAutomation$$.$w$ : $DvtTagCloudStyleUtils$$;
  };
  $DvtTagCloudItem$$.$_lightenColor$ = function $$DvtTagCloudItem$$$$_lightenColor$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    var $DvtTagCloudItem$$ = $dvt$$16$$.$ColorUtils$.$getRed$($DvtTagCloudAutomation$$), $DvtTagCloudDefaults$$ = $dvt$$16$$.$ColorUtils$.$getGreen$($DvtTagCloudAutomation$$), $DvtTagCloudRenderer$$ = $dvt$$16$$.$ColorUtils$.$getBlue$($DvtTagCloudAutomation$$);
    return $dvt$$16$$.$ColorUtils$.$makeRGB$(Math.floor(255 * (1 - $DvtTagCloudStyleUtils$$) + $DvtTagCloudStyleUtils$$ * $DvtTagCloudItem$$), Math.floor(255 * (1 - $DvtTagCloudStyleUtils$$) + $DvtTagCloudStyleUtils$$ * $DvtTagCloudDefaults$$), Math.floor(255 * (1 - $DvtTagCloudStyleUtils$$) + $DvtTagCloudStyleUtils$$ * $DvtTagCloudRenderer$$));
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudObjPeer$$, $dvt$$16$$.$Obj$);
  $DvtTagCloudObjPeer$$.prototype.Init = function $$DvtTagCloudObjPeer$$$$Init$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    this.$_view$ = $DvtTagCloudAutomation$$;
    this.$_displayable$ = $DvtTagCloudStyleUtils$$;
    this.$_data$ = $DvtTagCloudItem$$;
    this.$_bSelectable$ = this.$_isSelected$ = !1;
    $DvtTagCloudItem$$.url ? ($DvtTagCloudStyleUtils$$.$setAriaRole$("link"), this.$_linkCallback$ = $dvt$$16$$.$ToolkitUtils$.$getLinkCallback$("_blank", $DvtTagCloudItem$$.url)) : $DvtTagCloudStyleUtils$$.$setAriaRole$("img");
    this.$_updateAriaLabel$();
  };
  $DvtTagCloudObjPeer$$.prototype.getId = function $$DvtTagCloudObjPeer$$$$getId$() {
    return this.$_data$.id;
  };
  $DvtTagCloudObjPeer$$.prototype.$getLabel$ = function $$DvtTagCloudObjPeer$$$$$getLabel$$() {
    return this.$_data$.label;
  };
  $DvtTagCloudObjPeer$$.prototype.getValue = function $$DvtTagCloudObjPeer$$$$getValue$() {
    return this.$_data$.value;
  };
  $DvtTagCloudObjPeer$$.prototype.$getShortDesc$ = function $$DvtTagCloudObjPeer$$$$$getShortDesc$$() {
    return this.$_data$.shortDesc;
  };
  $DvtTagCloudObjPeer$$.prototype.$getAction$ = function $$DvtTagCloudObjPeer$$$$$getAction$$() {
    return this.$_data$.action;
  };
  $DvtTagCloudObjPeer$$.prototype.$getDatatip$ = function $$DvtTagCloudObjPeer$$$$$getDatatip$$() {
    var $dvt$$16$$ = this.$_view$.$getOptions$().tooltip;
    return ($dvt$$16$$ = $dvt$$16$$ ? $dvt$$16$$.renderer : null) ? this.$_view$.$getCtx$().$getTooltipManager$().$getCustomTooltip$($dvt$$16$$, this.$getDataContext$()) : this.$getShortDesc$();
  };
  $DvtTagCloudObjPeer$$.prototype.$getDataContext$ = function $$DvtTagCloudObjPeer$$$$$getDataContext$$() {
    return {id:this.getId(), label:this.$getLabel$(), color:this.$getDatatipColor$(), value:this.getValue()};
  };
  $DvtTagCloudObjPeer$$.prototype.$getLinkCallback$ = function $$DvtTagCloudObjPeer$$$$$getLinkCallback$$() {
    return this.$_linkCallback$;
  };
  $DvtTagCloudObjPeer$$.prototype.$getDatatipColor$ = function $$DvtTagCloudObjPeer$$$$$getDatatipColor$$() {
    return this.$_displayable$.$_normalStyle$.$getStyle$($dvt$$16$$.$CSSStyle$.$COLOR$);
  };
  $DvtTagCloudObjPeer$$.prototype.$setSelectable$ = function $$DvtTagCloudObjPeer$$$$$setSelectable$$($dvt$$16$$) {
    this.$_bSelectable$ = $dvt$$16$$;
  };
  $DvtTagCloudObjPeer$$.prototype.$isSelectable$ = function $$DvtTagCloudObjPeer$$$$$isSelectable$$() {
    return this.$_bSelectable$;
  };
  $DvtTagCloudObjPeer$$.prototype.$isSelected$ = function $$DvtTagCloudObjPeer$$$$$isSelected$$() {
    return this.$_isSelected$;
  };
  $DvtTagCloudObjPeer$$.prototype.$setSelected$ = function $$DvtTagCloudObjPeer$$$$$setSelected$$($dvt$$16$$) {
    this.$_isSelected$ = $dvt$$16$$;
    this.$_displayable$.$setSelected$($dvt$$16$$);
    this.$_updateAriaLabel$();
  };
  $DvtTagCloudObjPeer$$.prototype.$showHoverEffect$ = function $$DvtTagCloudObjPeer$$$$$showHoverEffect$$() {
    this.$_displayable$.$showHoverEffect$();
  };
  $DvtTagCloudObjPeer$$.prototype.$hideHoverEffect$ = function $$DvtTagCloudObjPeer$$$$$hideHoverEffect$$() {
    this.$_displayable$.$hideHoverEffect$();
  };
  $DvtTagCloudObjPeer$$.prototype.$getNextNavigable$ = function $$DvtTagCloudObjPeer$$$$$getNextNavigable$$($DvtTagCloudAutomation$$) {
    var $DvtTagCloudStyleUtils$$ = this.$_view$.$EventManager$.$KeyboardHandler$;
    return $DvtTagCloudAutomation$$.type == $dvt$$16$$.MouseEvent.$CLICK$ || $DvtTagCloudStyleUtils$$.$isMultiSelectEvent$($DvtTagCloudAutomation$$) ? this : $DvtTagCloudStyleUtils$$.$isNavigationEvent$($DvtTagCloudAutomation$$) ? $DvtTagCloudKeyboardHandler$$.$getNextNavigable$(this, $DvtTagCloudAutomation$$, this.$_view$.$getObjects$()) : null;
  };
  $DvtTagCloudObjPeer$$.prototype.$getKeyboardBoundingBox$ = function $$DvtTagCloudObjPeer$$$$$getKeyboardBoundingBox$$($dvt$$16$$) {
    return this.$_displayable$.$getDimensions$($dvt$$16$$);
  };
  $DvtTagCloudObjPeer$$.prototype.$getTargetElem$ = function $$DvtTagCloudObjPeer$$$$$getTargetElem$$() {
    return this.$_displayable$.$getElem$();
  };
  $DvtTagCloudObjPeer$$.prototype.$showKeyboardFocusEffect$ = function $$DvtTagCloudObjPeer$$$$$showKeyboardFocusEffect$$() {
    this.$_isShowingKeyboardFocusEffect$ = !0;
    this.$showHoverEffect$();
  };
  $DvtTagCloudObjPeer$$.prototype.$hideKeyboardFocusEffect$ = function $$DvtTagCloudObjPeer$$$$$hideKeyboardFocusEffect$$() {
    this.$_isShowingKeyboardFocusEffect$ && (this.$_isShowingKeyboardFocusEffect$ = !1, this.$hideHoverEffect$());
  };
  $DvtTagCloudObjPeer$$.prototype.$isShowingKeyboardFocusEffect$ = function $$DvtTagCloudObjPeer$$$$$isShowingKeyboardFocusEffect$$() {
    return this.$_isShowingKeyboardFocusEffect$;
  };
  $DvtTagCloudObjPeer$$.prototype.$getDisplayables$ = function $$DvtTagCloudObjPeer$$$$$getDisplayables$$() {
    return [this.$_displayable$];
  };
  $DvtTagCloudObjPeer$$.prototype.$getAriaLabel$ = function $$DvtTagCloudObjPeer$$$$$getAriaLabel$$() {
    var $DvtTagCloudAutomation$$ = [];
    this.$isSelectable$() && $DvtTagCloudAutomation$$.push($dvt$$16$$.$Bundle$.$getTranslatedString$($dvt$$16$$.$Bundle$.$UTIL_PREFIX$, this.$isSelected$() ? "STATE_SELECTED" : "STATE_UNSELECTED"));
    return $dvt$$16$$.$Displayable$.$generateAriaLabel$(this.$getShortDesc$(), $DvtTagCloudAutomation$$);
  };
  $DvtTagCloudObjPeer$$.prototype.$getCategories$ = function $$DvtTagCloudObjPeer$$$$$getCategories$$() {
    return this.$_data$.categories;
  };
  $DvtTagCloudObjPeer$$.prototype.$_updateAriaLabel$ = function $$DvtTagCloudObjPeer$$$$$_updateAriaLabel$$() {
    $dvt$$16$$.$Agent$.$deferAriaCreation$() || this.$_displayable$.$setAriaProperty$("label", this.$getAriaLabel$());
  };
  $DvtTagCloudObjPeer$$.prototype.$getShowPopupBehaviors$ = function $$DvtTagCloudObjPeer$$$$$getShowPopupBehaviors$$() {
    if (!this.$_showPopupBehaviors$ && (this.$_showPopupBehaviors$ = [], this.$_data$.showPopupBehaviors)) {
      for (var $DvtTagCloudAutomation$$ = this.$_data$.showPopupBehaviors, $DvtTagCloudStyleUtils$$ = 0;$DvtTagCloudStyleUtils$$ < $DvtTagCloudAutomation$$.length;$DvtTagCloudStyleUtils$$++) {
        this.$_showPopupBehaviors$.push(new $dvt$$16$$.$ShowPopupBehavior$($DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$].popupId, $DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$].triggerType, $DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$].alignId, $DvtTagCloudAutomation$$[$DvtTagCloudStyleUtils$$].align));
      }
    }
    return this.$_showPopupBehaviors$;
  };
  $DvtTagCloudObjPeer$$.prototype.$isDragAvailable$ = function $$DvtTagCloudObjPeer$$$$$isDragAvailable$$($dvt$$16$$) {
    return this.$_view$.$isDragSupported$($dvt$$16$$);
  };
  $DvtTagCloudObjPeer$$.prototype.$getDragTransferable$ = function $$DvtTagCloudObjPeer$$$$$getDragTransferable$$() {
    return this.$_view$.$getDragRowKeys$(this);
  };
  $DvtTagCloudObjPeer$$.prototype.$getDragFeedback$ = function $$DvtTagCloudObjPeer$$$$$getDragFeedback$$() {
    return this.$_view$.$getDragFeedback$();
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudDefaults$$, $dvt$$16$$.$BaseComponentDefaults$);
  $DvtTagCloudDefaults$$.$VERSION_1$ = {animationOnDisplay:"none", animationOnDataChange:"none", emptyText:null, hiddenCategories:[], hideAndShowBehavior:"none", highlightedCategories:[], highlightMatch:"all", hoverBehavior:"none", layout:"rectangular", selectionMode:"none", _statusMessageStyle:new $dvt$$16$$.$CSSStyle$($dvt$$16$$.$BaseComponentDefaults$.$FONT_FAMILY_ALTA$ + "color: #333333;"), styleDefaults:{animationDuration:500, hoverBehaviorDelay:200, _style:new $dvt$$16$$.$CSSStyle$($dvt$$16$$.$BaseComponentDefaults$.$FONT_FAMILY_ALTA$ + 
  "color: #333333;")}, touchResponse:"auto"};
  var $DvtTagCloudRenderer$$ = {};
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudRenderer$$, $dvt$$16$$.$Obj$);
  $DvtTagCloudRenderer$$.$render$ = function $$DvtTagCloudRenderer$$$$render$$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    $DvtTagCloudRenderer$$.$_renderBackground$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$);
    $DvtTagCloudRenderer$$.$_renderLegend$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$);
    $DvtTagCloudRenderer$$.$_adjustAvailSpace$($DvtTagCloudStyleUtils$$);
    var $DvtTagCloudItem$$ = $dvt$$16$$.$getOptions$();
    $DvtTagCloudItem$$.items && 0 < $DvtTagCloudItem$$.items.length ? ($DvtTagCloudItem$$ = $DvtTagCloudRenderer$$.$_renderItems$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$), 0 < $DvtTagCloudItem$$.length ? ($dvt$$16$$.$registerItems$($DvtTagCloudItem$$), $dvt$$16$$.$EventManager$.$setFocusObj$($dvt$$16$$.$getObjects$()[0])) : $DvtTagCloudRenderer$$.$_renderEmptyText$($dvt$$16$$, $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$)) : $DvtTagCloudRenderer$$.$_renderEmptyText$($dvt$$16$$, 
    $DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$);
  };
  $DvtTagCloudRenderer$$.$_renderEmptyText$ = function $$DvtTagCloudRenderer$$$$_renderEmptyText$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    var $DvtTagCloudDefaults$$ = $DvtTagCloudAutomation$$.$getOptions$(), $DvtTagCloudRenderer$$ = $DvtTagCloudDefaults$$.emptyText;
    $DvtTagCloudRenderer$$ || ($DvtTagCloudRenderer$$ = $dvt$$16$$.$Bundle$.$getTranslation$($DvtTagCloudDefaults$$, "labelNoData", $dvt$$16$$.$Bundle$.$UTIL_PREFIX$, "NO_DATA", null));
    $dvt$$16$$.$TextUtils$.$renderEmptyText$($DvtTagCloudStyleUtils$$, $DvtTagCloudRenderer$$, new $dvt$$16$$.$Rectangle$($DvtTagCloudItem$$.x, $DvtTagCloudItem$$.y, $DvtTagCloudItem$$.$w$, $DvtTagCloudItem$$.$h$), $DvtTagCloudAutomation$$.$EventManager$, $DvtTagCloudDefaults$$._statusMessageStyle);
  };
  $DvtTagCloudRenderer$$.$_renderBackground$ = function $$DvtTagCloudRenderer$$$$_renderBackground$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    $DvtTagCloudAutomation$$ = new $dvt$$16$$.Rect($DvtTagCloudAutomation$$.$getCtx$(), $DvtTagCloudItem$$.x, $DvtTagCloudItem$$.y, $DvtTagCloudItem$$.$w$, $DvtTagCloudItem$$.$h$);
    $DvtTagCloudAutomation$$.$setInvisibleFill$();
    $DvtTagCloudStyleUtils$$.$addChild$($DvtTagCloudAutomation$$);
  };
  $DvtTagCloudRenderer$$.$_renderItems$ = function $$DvtTagCloudRenderer$$$$_renderItems$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudDefaults$$) {
    for (var $DvtTagCloudRenderer$$ = $DvtTagCloudAutomation$$.$getOptions$(), $items$$33$$ = [], $dataItems$$2$$ = $DvtTagCloudRenderer$$.items, $fontSizeFunction_minValue$$14$$ = Number.MAX_VALUE, $categoryMap$$2_maxValue$$15$$ = -Number.MAX_VALUE, $i$$602$$ = 0;$i$$602$$ < $dataItems$$2$$.length;$i$$602$$++) {
      $fontSizeFunction_minValue$$14$$ = Math.min($fontSizeFunction_minValue$$14$$, $dataItems$$2$$[$i$$602$$].value), $categoryMap$$2_maxValue$$15$$ = Math.max($categoryMap$$2_maxValue$$15$$, $dataItems$$2$$[$i$$602$$].value);
    }
    var $fontSizeFunction_minValue$$14$$ = $DvtTagCloudLayoutUtils$$.$getFontSizeFunction$($fontSizeFunction_minValue$$14$$, $categoryMap$$2_maxValue$$15$$), $categoryMap$$2_maxValue$$15$$ = $dvt$$16$$.$ArrayUtils$.$createBooleanMap$($DvtTagCloudRenderer$$.hiddenCategories), $textProperties$$ = $dvt$$16$$.$CSSStyle$.$getTextMeasurementProperties$(), $styleDefaults$$6$$ = $DvtTagCloudRenderer$$.styleDefaults, $defaultStyle$$2$$ = $styleDefaults$$6$$.svgStyle || $styleDefaults$$6$$.style;
    !$defaultStyle$$2$$ || $defaultStyle$$2$$ instanceof Object || ($defaultStyle$$2$$ = $dvt$$16$$.$CSSStyle$.$cssStringToObject$($defaultStyle$$2$$));
    for ($i$$602$$ = 0;$i$$602$$ < $dataItems$$2$$.length;$i$$602$$++) {
      var $data$$110$$ = $dataItems$$2$$[$i$$602$$];
      $data$$110$$.categories || ($data$$110$$.categories = [$data$$110$$.label]);
      if (!$categoryMap$$2_maxValue$$15$$ || !$dvt$$16$$.$ArrayUtils$.$hasAnyMapItem$($categoryMap$$2_maxValue$$15$$, $data$$110$$.categories)) {
        var $item$$50_style$$111$$ = $styleDefaults$$6$$._style.clone(), $itemStyle$$2_peer$$36$$ = $data$$110$$.svgStyle || $data$$110$$.style;
        !$itemStyle$$2_peer$$36$$ || $itemStyle$$2_peer$$36$$ instanceof Object || ($itemStyle$$2_peer$$36$$ = $dvt$$16$$.$CSSStyle$.$cssStringToObject$($itemStyle$$2_peer$$36$$));
        var $color$$70$$ = $itemStyle$$2_peer$$36$$ && $itemStyle$$2_peer$$36$$.color ? $itemStyle$$2_peer$$36$$.color : $data$$110$$.color ? $data$$110$$.color : $defaultStyle$$2$$ && $defaultStyle$$2$$.color ? $defaultStyle$$2$$.color : null;
        if ($itemStyle$$2_peer$$36$$ = $dvt$$16$$.$JsonUtils$.$merge$($itemStyle$$2_peer$$36$$, $defaultStyle$$2$$)) {
          for (var $index$$195$$ = 0;$index$$195$$ < $textProperties$$.length;$index$$195$$++) {
            var $DvtTagCloudEventManager$$ = $dvt$$16$$.$CSSStyle$.$cssStringToObjectProperty$($textProperties$$[$index$$195$$]);
            $itemStyle$$2_peer$$36$$[$DvtTagCloudEventManager$$] && ($item$$50_style$$111$$.$setStyle$($textProperties$$[$index$$195$$], $itemStyle$$2_peer$$36$$[$DvtTagCloudEventManager$$]), delete $itemStyle$$2_peer$$36$$[$DvtTagCloudEventManager$$]);
          }
          delete $itemStyle$$2_peer$$36$$.color;
        }
        $color$$70$$ && $item$$50_style$$111$$.$setStyle$($dvt$$16$$.$CSSStyle$.$COLOR$, $color$$70$$);
        $item$$50_style$$111$$.$setStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$, $fontSizeFunction_minValue$$14$$.call(null, $data$$110$$.value).toString());
        $item$$50_style$$111$$ = new $DvtTagCloudItem$$($DvtTagCloudAutomation$$, $DvtTagCloudAutomation$$.$getCtx$(), $data$$110$$.label, 0, 0, $item$$50_style$$111$$, $itemStyle$$2_peer$$36$$, $data$$110$$.svgClassName || $data$$110$$.className, $data$$110$$.id);
        $itemStyle$$2_peer$$36$$ = new $DvtTagCloudObjPeer$$($DvtTagCloudAutomation$$, $item$$50_style$$111$$, $data$$110$$);
        $DvtTagCloudAutomation$$.$EventManager$.$associate$($item$$50_style$$111$$, $itemStyle$$2_peer$$36$$);
        $DvtTagCloudAutomation$$.$registerObject$($itemStyle$$2_peer$$36$$, $i$$602$$);
        "none" !== $DvtTagCloudRenderer$$.selectionMode && $itemStyle$$2_peer$$36$$.$setSelectable$(!0);
        ($itemStyle$$2_peer$$36$$.$isSelectable$() || $data$$110$$.url || $itemStyle$$2_peer$$36$$.$getAction$()) && $item$$50_style$$111$$.setCursor("pointer");
        $items$$33$$.push($item$$50_style$$111$$);
        $DvtTagCloudStyleUtils$$.$addChild$($item$$50_style$$111$$);
      }
    }
    0 < $items$$33$$.length && ("cloud" === $DvtTagCloudRenderer$$.layout ? $DvtTagCloudLayoutUtils$$.$cloudLayout$($DvtTagCloudDefaults$$, $items$$33$$) : $DvtTagCloudLayoutUtils$$.$rectangleLayout$($DvtTagCloudDefaults$$, $items$$33$$, $dvt$$16$$.$Agent$.$isRightToLeft$($DvtTagCloudAutomation$$.$getCtx$())));
    return $items$$33$$;
  };
  $DvtTagCloudRenderer$$.$_renderLegend$ = function $$DvtTagCloudRenderer$$$$_renderLegend$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    var $DvtTagCloudDefaults$$ = $DvtTagCloudAutomation$$.$getOptions$(), $DvtTagCloudRenderer$$ = $DvtTagCloudDefaults$$.legend;
    if ($DvtTagCloudRenderer$$ && $DvtTagCloudRenderer$$.sections) {
      $DvtTagCloudRenderer$$ = $dvt$$16$$.$JsonUtils$.clone($DvtTagCloudRenderer$$);
      $DvtTagCloudRenderer$$.orientation = "horizontal";
      $DvtTagCloudRenderer$$.halign = "center";
      $DvtTagCloudRenderer$$.hoverBehavior = $DvtTagCloudDefaults$$.hoverBehavior;
      $DvtTagCloudRenderer$$.hideAndShowBehavior = $DvtTagCloudDefaults$$.hideAndShowBehavior;
      $DvtTagCloudRenderer$$.hiddenCategories = $DvtTagCloudDefaults$$.hiddenCategories;
      $DvtTagCloudDefaults$$ = $dvt$$16$$.$Legend$.newInstance($DvtTagCloudAutomation$$.$getCtx$(), $DvtTagCloudAutomation$$.$processEvent$, $DvtTagCloudAutomation$$);
      $DvtTagCloudStyleUtils$$.$addChild$($DvtTagCloudDefaults$$);
      var $DvtTagCloudObjPeer$$ = $DvtTagCloudDefaults$$.$getPreferredSize$($DvtTagCloudRenderer$$, $DvtTagCloudItem$$.$w$, $DvtTagCloudItem$$.$h$ / 3);
      $DvtTagCloudDefaults$$.$render$($DvtTagCloudRenderer$$, $DvtTagCloudObjPeer$$.$w$, $DvtTagCloudObjPeer$$.$h$);
      $dvt$$16$$.$LayoutUtils$.position($DvtTagCloudItem$$, "bottom", $DvtTagCloudDefaults$$, $DvtTagCloudObjPeer$$.$w$, $DvtTagCloudObjPeer$$.$h$, 0);
      $DvtTagCloudAutomation$$.$legend$ && ($DvtTagCloudAutomation$$.$legend$.$destroy$(), $DvtTagCloudStyleUtils$$.removeChild($DvtTagCloudAutomation$$.$legend$));
      $DvtTagCloudAutomation$$.$legend$ = $DvtTagCloudDefaults$$;
    }
  };
  $DvtTagCloudRenderer$$.$_adjustAvailSpace$ = function $$DvtTagCloudRenderer$$$$_adjustAvailSpace$$($dvt$$16$$) {
    $dvt$$16$$.x = Math.round($dvt$$16$$.x);
    $dvt$$16$$.y = Math.round($dvt$$16$$.y);
    $dvt$$16$$.$w$ = Math.round($dvt$$16$$.$w$);
    $dvt$$16$$.$h$ = Math.round($dvt$$16$$.$h$);
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudLayoutUtils$$, $dvt$$16$$.$Obj$);
  $DvtTagCloudLayoutUtils$$.$getFontSizeFunction$ = function $$DvtTagCloudLayoutUtils$$$$getFontSizeFunction$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    return function($DvtTagCloudStyleUtils$$) {
      return 12 + Math.ceil(2 * ($DvtTagCloudStyleUtils$$ - $dvt$$16$$) / ($DvtTagCloudAutomation$$ - $dvt$$16$$) * 12);
    };
  };
  $DvtTagCloudLayoutUtils$$.$cloudLayout$ = function $$DvtTagCloudLayoutUtils$$$$cloudLayout$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$) {
    var $DvtTagCloudItem$$ = [], $DvtTagCloudDefaults$$ = 10 / 180, $DvtTagCloudRenderer$$ = 10 / 180;
    $DvtTagCloudAutomation$$.$w$ > $DvtTagCloudAutomation$$.$h$ ? $DvtTagCloudDefaults$$ *= $DvtTagCloudAutomation$$.$w$ / $DvtTagCloudAutomation$$.$h$ : $DvtTagCloudRenderer$$ *= $DvtTagCloudAutomation$$.$h$ / $DvtTagCloudAutomation$$.$w$;
    for (var $DvtTagCloudObjPeer$$ = 2 * Math.PI / 180, $bounds$$121_cy$$34$$ = null, $maxFontSize$$ = 0, $cosCache$$ = [], $sinCache$$ = [], $i$$603$$ = 0;$i$$603$$ < $DvtTagCloudStyleUtils$$.length;$i$$603$$++) {
      for (var $placed$$ = !1, $step$$4$$ = 0, $stepIncrement$$ = 4, $tag$$2$$ = $DvtTagCloudStyleUtils$$[$i$$603$$], $dims$$59$$ = $tag$$2$$.$getDimensions$(), $maxFontSize$$ = Math.max($maxFontSize$$, parseFloat($tag$$2$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$))), $lastCollisionIndex$$ = -1;!$placed$$;) {
        var $DvtTagCloudEventManager$$ = $step$$4$$ % 180;
        void 0 === $cosCache$$[$DvtTagCloudEventManager$$] && ($cosCache$$[$DvtTagCloudEventManager$$] = Math.cos($step$$4$$ * $DvtTagCloudObjPeer$$));
        void 0 === $sinCache$$[$DvtTagCloudEventManager$$] && ($sinCache$$[$DvtTagCloudEventManager$$] = Math.sin($step$$4$$ * $DvtTagCloudObjPeer$$));
        var $DvtTagCloudLayoutUtils$$ = $DvtTagCloudDefaults$$ * $step$$4$$ * $cosCache$$[$DvtTagCloudEventManager$$], $y$$182$$ = $DvtTagCloudRenderer$$ * $step$$4$$ * $sinCache$$[$DvtTagCloudEventManager$$], $DvtTagCloudKeyboardHandler$$ = new $dvt$$16$$.$Rectangle$($DvtTagCloudLayoutUtils$$, $y$$182$$, $dims$$59$$.$w$, $dims$$59$$.$h$), $placed$$ = !0;
        -1 != $lastCollisionIndex$$ && $DvtTagCloudItem$$[$lastCollisionIndex$$].$intersects$($DvtTagCloudKeyboardHandler$$) && ($placed$$ = !1);
        if ($placed$$) {
          for ($DvtTagCloudEventManager$$ = 0;$DvtTagCloudEventManager$$ < $i$$603$$;$DvtTagCloudEventManager$$++) {
            if ($DvtTagCloudItem$$[$DvtTagCloudEventManager$$].$intersects$($DvtTagCloudKeyboardHandler$$)) {
              $lastCollisionIndex$$ = $DvtTagCloudEventManager$$;
              $placed$$ = !1;
              break;
            }
          }
        }
        $placed$$ && ($bounds$$121_cy$$34$$ = $bounds$$121_cy$$34$$ ? $bounds$$121_cy$$34$$.$getUnion$($DvtTagCloudKeyboardHandler$$) : $DvtTagCloudKeyboardHandler$$, $lastCollisionIndex$$ = -1, $DvtTagCloudItem$$[$i$$603$$] = $DvtTagCloudKeyboardHandler$$, $tag$$2$$.$setX$($DvtTagCloudLayoutUtils$$), $tag$$2$$.$setY$(-$dims$$59$$.y + $y$$182$$));
        3600 === $step$$4$$ ? $stepIncrement$$ = 3 : 5400 === $step$$4$$ ? $stepIncrement$$ = 2 : 10800 === $step$$4$$ && ($stepIncrement$$ = 1);
        $step$$4$$ += $stepIncrement$$;
      }
    }
    $DvtTagCloudItem$$ = Math.max($bounds$$121_cy$$34$$.$w$ / $DvtTagCloudAutomation$$.$w$, $bounds$$121_cy$$34$$.$h$ / $DvtTagCloudAutomation$$.$h$);
    $DvtTagCloudDefaults$$ = $bounds$$121_cy$$34$$.x + $bounds$$121_cy$$34$$.$w$ / 2;
    $bounds$$121_cy$$34$$ = $bounds$$121_cy$$34$$.y + $bounds$$121_cy$$34$$.$h$ / 2;
    for ($DvtTagCloudEventManager$$ = 0;$DvtTagCloudEventManager$$ < $DvtTagCloudStyleUtils$$.length;$DvtTagCloudEventManager$$++) {
      $tag$$2$$ = $DvtTagCloudStyleUtils$$[$DvtTagCloudEventManager$$], $tag$$2$$.$setX$($DvtTagCloudAutomation$$.x + $tag$$2$$.$getX$() / $DvtTagCloudItem$$ + ($DvtTagCloudAutomation$$.$w$ / 2 - $DvtTagCloudDefaults$$ / $DvtTagCloudItem$$)), $tag$$2$$.$setY$($DvtTagCloudAutomation$$.y + $tag$$2$$.$getY$() / $DvtTagCloudItem$$ + ($DvtTagCloudAutomation$$.$h$ / 2 - $bounds$$121_cy$$34$$ / $DvtTagCloudItem$$)), $DvtTagCloudRenderer$$ = parseFloat($tag$$2$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$)), 
      $tag$$2$$.$setFontSize$($DvtTagCloudRenderer$$ / $DvtTagCloudItem$$);
    }
  };
  $DvtTagCloudLayoutUtils$$.$rectangleLayout$ = function $$DvtTagCloudLayoutUtils$$$$rectangleLayout$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    for (var $DvtTagCloudDefaults$$ = [], $DvtTagCloudRenderer$$ = 0, $DvtTagCloudObjPeer$$ = 0, $arLines_maxFontSize$$1$$ = 0, $i$$604_minScale$$3$$ = 0;$i$$604_minScale$$3$$ < $DvtTagCloudStyleUtils$$.length;$i$$604_minScale$$3$$++) {
      var $lineWidth$$7_maxScale_tag$$3$$ = $DvtTagCloudStyleUtils$$[$i$$604_minScale$$3$$], $dims$$60_lineStart$$ = $lineWidth$$7_maxScale_tag$$3$$.$getDimensions$(), $DvtTagCloudRenderer$$ = Math.max($DvtTagCloudRenderer$$, $dims$$60_lineStart$$.$w$), $DvtTagCloudObjPeer$$ = Math.max($DvtTagCloudObjPeer$$, $dims$$60_lineStart$$.$h$), $arLines_maxFontSize$$1$$ = Math.max($arLines_maxFontSize$$1$$, parseFloat($lineWidth$$7_maxScale_tag$$3$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$)));
      $DvtTagCloudDefaults$$.push(new $dvt$$16$$.$Dimension$($dims$$60_lineStart$$.$w$, $dims$$60_lineStart$$.$h$));
    }
    $i$$604_minScale$$3$$ = 0;
    for ($lineWidth$$7_maxScale_tag$$3$$ = ($DvtTagCloudAutomation$$.$w$ - 10) / $DvtTagCloudRenderer$$;.001 < $lineWidth$$7_maxScale_tag$$3$$ - $i$$604_minScale$$3$$;) {
      $DvtTagCloudRenderer$$ = ($i$$604_minScale$$3$$ + $lineWidth$$7_maxScale_tag$$3$$) / 2, $arLines_maxFontSize$$1$$ = $DvtTagCloudLayoutUtils$$.$_calculateLineBreaks$($DvtTagCloudDefaults$$, ($DvtTagCloudAutomation$$.$w$ - 10) / $DvtTagCloudRenderer$$), $arLines_maxFontSize$$1$$.length * ($DvtTagCloudRenderer$$ * $DvtTagCloudObjPeer$$ + 2) - 2 > $DvtTagCloudAutomation$$.$h$ - 10 ? $lineWidth$$7_maxScale_tag$$3$$ = $DvtTagCloudRenderer$$ : $i$$604_minScale$$3$$ = $DvtTagCloudRenderer$$;
    }
    $DvtTagCloudRenderer$$ = $i$$604_minScale$$3$$;
    $arLines_maxFontSize$$1$$ = $DvtTagCloudLayoutUtils$$.$_calculateLineBreaks$($DvtTagCloudDefaults$$, ($DvtTagCloudAutomation$$.$w$ - 10) / $DvtTagCloudRenderer$$);
    $arLines_maxFontSize$$1$$.push($DvtTagCloudStyleUtils$$.length);
    for ($i$$604_minScale$$3$$ = 0;$i$$604_minScale$$3$$ < $arLines_maxFontSize$$1$$.length - 1;$i$$604_minScale$$3$$++) {
      var $dims$$60_lineStart$$ = $arLines_maxFontSize$$1$$[$i$$604_minScale$$3$$], $lineEnd$$ = $arLines_maxFontSize$$1$$[$i$$604_minScale$$3$$ + 1], $hPadding$$1$$ = 0, $bottomY$$1_maxLineHeight$$ = 0, $justified$$ = !0;
      if (1 < $lineEnd$$ - $dims$$60_lineStart$$) {
        for (var $lineWidth$$7_maxScale_tag$$3$$ = 0, $flowPadding_j$$81$$ = $dims$$60_lineStart$$;$flowPadding_j$$81$$ < $lineEnd$$;$flowPadding_j$$81$$++) {
          $lineWidth$$7_maxScale_tag$$3$$ += $DvtTagCloudDefaults$$[$flowPadding_j$$81$$].$w$ * $DvtTagCloudRenderer$$, $bottomY$$1_maxLineHeight$$ = Math.max($bottomY$$1_maxLineHeight$$, $DvtTagCloudDefaults$$[$flowPadding_j$$81$$].$h$ * $DvtTagCloudRenderer$$);
        }
        $hPadding$$1$$ = ($DvtTagCloudAutomation$$.$w$ - 10 - $lineWidth$$7_maxScale_tag$$3$$) / ($lineEnd$$ - $dims$$60_lineStart$$ - 1);
        $i$$604_minScale$$3$$ == $arLines_maxFontSize$$1$$.length - 2 && ($flowPadding_j$$81$$ = .5 * $bottomY$$1_maxLineHeight$$, $flowPadding_j$$81$$ < $hPadding$$1$$ && $lineWidth$$7_maxScale_tag$$3$$ + ($lineEnd$$ - $dims$$60_lineStart$$) * $flowPadding_j$$81$$ < .9 * ($DvtTagCloudAutomation$$.$w$ - 10) && ($hPadding$$1$$ = $flowPadding_j$$81$$, $justified$$ = !1));
      }
      for (var $bottomY$$1_maxLineHeight$$ = 5 + ($i$$604_minScale$$3$$ + 1) * ($DvtTagCloudObjPeer$$ * $DvtTagCloudRenderer$$ + 2) - 2, $curX$$2$$ = $DvtTagCloudItem$$ ? $DvtTagCloudAutomation$$.$w$ - 5 : 5, $flowPadding_j$$81$$ = $dims$$60_lineStart$$;$flowPadding_j$$81$$ < $lineEnd$$;$flowPadding_j$$81$$++) {
        var $lineWidth$$7_maxScale_tag$$3$$ = $DvtTagCloudStyleUtils$$[$flowPadding_j$$81$$], $fontSize$$10$$ = parseFloat($lineWidth$$7_maxScale_tag$$3$$.$getCSSStyle$().$getStyle$($dvt$$16$$.$CSSStyle$.$FONT_SIZE$));
        $lineWidth$$7_maxScale_tag$$3$$.$setFontSize$($fontSize$$10$$ * $DvtTagCloudRenderer$$);
        $lineWidth$$7_maxScale_tag$$3$$.$setY$($DvtTagCloudAutomation$$.y + $bottomY$$1_maxLineHeight$$);
        $justified$$ && $flowPadding_j$$81$$ == $lineEnd$$ - 1 && $flowPadding_j$$81$$ != $dims$$60_lineStart$$ ? $DvtTagCloudItem$$ ? ($lineWidth$$7_maxScale_tag$$3$$.$alignLeft$(), $lineWidth$$7_maxScale_tag$$3$$.$setX$($DvtTagCloudAutomation$$.x + 5)) : ($lineWidth$$7_maxScale_tag$$3$$.$alignRight$(), $lineWidth$$7_maxScale_tag$$3$$.$setX$($DvtTagCloudAutomation$$.x + $DvtTagCloudAutomation$$.$w$ - 5)) : ($lineWidth$$7_maxScale_tag$$3$$.$setX$($DvtTagCloudAutomation$$.x + $curX$$2$$), $DvtTagCloudItem$$ ? 
        ($lineWidth$$7_maxScale_tag$$3$$.$alignRight$(), $curX$$2$$ -= $DvtTagCloudDefaults$$[$flowPadding_j$$81$$].$w$ * $DvtTagCloudRenderer$$ + $hPadding$$1$$) : ($lineWidth$$7_maxScale_tag$$3$$.$alignLeft$(), $curX$$2$$ += $DvtTagCloudDefaults$$[$flowPadding_j$$81$$].$w$ * $DvtTagCloudRenderer$$ + $hPadding$$1$$));
      }
    }
  };
  $DvtTagCloudLayoutUtils$$.$_calculateLineBreaks$ = function $$DvtTagCloudLayoutUtils$$$$_calculateLineBreaks$$($dvt$$16$$, $DvtTagCloudAutomation$$) {
    var $DvtTagCloudStyleUtils$$ = [0], $DvtTagCloudItem$$ = $dvt$$16$$[0].$w$ + 2;
    if (1 < $dvt$$16$$.length) {
      for (var $DvtTagCloudDefaults$$ = 1;$DvtTagCloudDefaults$$ < $dvt$$16$$.length;$DvtTagCloudDefaults$$++) {
        $DvtTagCloudItem$$ + $dvt$$16$$[$DvtTagCloudDefaults$$].$w$ > $DvtTagCloudAutomation$$ && ($DvtTagCloudStyleUtils$$.push($DvtTagCloudDefaults$$), $DvtTagCloudItem$$ = 0), $DvtTagCloudItem$$ += $dvt$$16$$[$DvtTagCloudDefaults$$].$w$ + 2;
      }
    }
    return $DvtTagCloudStyleUtils$$;
  };
  var $DvtTagCloudStyleUtils$$ = {};
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudStyleUtils$$, $dvt$$16$$.$Obj$);
  $DvtTagCloudStyleUtils$$.$getAnimationDuration$ = function $$DvtTagCloudStyleUtils$$$$getAnimationDuration$$($dvt$$16$$) {
    return $dvt$$16$$.$getOptions$().styleDefaults.animationDuration / 1E3;
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudEventManager$$, $dvt$$16$$.$EventManager$);
  $DvtTagCloudEventManager$$.prototype.$OnClickInternal$ = function $$DvtTagCloudEventManager$$$$$OnClickInternal$$($dvt$$16$$) {
    $dvt$$16$$ = this.$GetLogicalObject$($dvt$$16$$.target);
    this.$_handleLinkCallback$($dvt$$16$$);
    this.$_processActionEvent$($dvt$$16$$);
  };
  $DvtTagCloudEventManager$$.prototype.$HandleTouchHoverEndInternal$ = function $$DvtTagCloudEventManager$$$$$HandleTouchHoverEndInternal$$($dvt$$16$$) {
    $dvt$$16$$ = this.$GetLogicalObject$($dvt$$16$$.target);
    this.$_processActionEvent$($dvt$$16$$);
  };
  $DvtTagCloudEventManager$$.prototype.$HandleTouchClickInternal$ = function $$DvtTagCloudEventManager$$$$$HandleTouchClickInternal$$($dvt$$16$$) {
    $dvt$$16$$ = this.$GetLogicalObject$($dvt$$16$$.target);
    this.$_handleLinkCallback$($dvt$$16$$);
    this.$_processActionEvent$($dvt$$16$$);
  };
  $DvtTagCloudEventManager$$.prototype.$_handleLinkCallback$ = function $$DvtTagCloudEventManager$$$$$_handleLinkCallback$$($dvt$$16$$) {
    $dvt$$16$$ instanceof $DvtTagCloudObjPeer$$ && ($dvt$$16$$ = $dvt$$16$$.$getLinkCallback$()) && $dvt$$16$$.call();
  };
  $DvtTagCloudEventManager$$.prototype.$ProcessKeyboardEvent$ = function $$DvtTagCloudEventManager$$$$$ProcessKeyboardEvent$$($DvtTagCloudAutomation$$) {
    var $DvtTagCloudStyleUtils$$ = !0, $DvtTagCloudItem$$ = this.$getFocus$();
    $DvtTagCloudAutomation$$.keyCode == $dvt$$16$$.KeyboardEvent.$ENTER$ ? this.$_handleLinkCallback$($DvtTagCloudItem$$) : $DvtTagCloudStyleUtils$$ = $DvtTagCloudEventManager$$.$superclass$.$ProcessKeyboardEvent$.call(this, $DvtTagCloudAutomation$$);
    return $DvtTagCloudStyleUtils$$;
  };
  $DvtTagCloudEventManager$$.prototype.$ProcessRolloverEvent$ = function $$DvtTagCloudEventManager$$$$$ProcessRolloverEvent$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    $DvtTagCloudAutomation$$ = this.$_view$.$getOptions$();
    "dim" == $DvtTagCloudAutomation$$.hoverBehavior && ($DvtTagCloudStyleUtils$$ = $DvtTagCloudStyleUtils$$.$getCategories$ ? $DvtTagCloudStyleUtils$$.$getCategories$() : [], $DvtTagCloudAutomation$$.highlightedCategories = $DvtTagCloudItem$$ ? $DvtTagCloudStyleUtils$$.slice() : null, $DvtTagCloudItem$$ = $dvt$$16$$.$EventFactory$.$newCategoryHighlightEvent$($DvtTagCloudAutomation$$.highlightedCategories, $DvtTagCloudItem$$), $DvtTagCloudStyleUtils$$ = $dvt$$16$$.$StyleUtils$.$getTimeMilliseconds$($DvtTagCloudAutomation$$.styleDefaults.hoverBehaviorDelay), 
    this.$RolloverHandler$.$processEvent$($DvtTagCloudItem$$, this.$_view$.$getObjects$(), $DvtTagCloudStyleUtils$$, "any" == $DvtTagCloudAutomation$$.highlightMatch));
  };
  $DvtTagCloudEventManager$$.prototype.$_processActionEvent$ = function $$DvtTagCloudEventManager$$$$$_processActionEvent$$($DvtTagCloudAutomation$$) {
    $DvtTagCloudAutomation$$ && $DvtTagCloudAutomation$$.$getAction$ && $DvtTagCloudAutomation$$.$getAction$() && this.$FireEvent$($dvt$$16$$.$EventFactory$.$newActionEvent$("action", $DvtTagCloudAutomation$$.$getAction$(), $DvtTagCloudAutomation$$.getId()));
  };
  $DvtTagCloudEventManager$$.prototype.$GetTouchResponse$ = function $$DvtTagCloudEventManager$$$$$GetTouchResponse$$() {
    return this.$_view$.$getOptions$().touchResponse;
  };
  $dvt$$16$$.$Obj$.$createSubclass$($DvtTagCloudKeyboardHandler$$, $dvt$$16$$.$KeyboardHandler$);
  $DvtTagCloudKeyboardHandler$$.prototype.Init = function $$DvtTagCloudKeyboardHandler$$$$Init$($dvt$$16$$) {
    $DvtTagCloudKeyboardHandler$$.$superclass$.Init.call(this, $dvt$$16$$);
  };
  $DvtTagCloudKeyboardHandler$$.prototype.$isSelectionEvent$ = function $$DvtTagCloudKeyboardHandler$$$$$isSelectionEvent$$($dvt$$16$$) {
    return this.$isNavigationEvent$($dvt$$16$$) && !$dvt$$16$$.ctrlKey;
  };
  $DvtTagCloudKeyboardHandler$$.prototype.$isMultiSelectEvent$ = function $$DvtTagCloudKeyboardHandler$$$$$isMultiSelectEvent$$($DvtTagCloudAutomation$$) {
    return $DvtTagCloudAutomation$$.keyCode == $dvt$$16$$.KeyboardEvent.$SPACE$ && $DvtTagCloudAutomation$$.ctrlKey;
  };
  $DvtTagCloudKeyboardHandler$$.$getNextNavigable$ = function $$DvtTagCloudKeyboardHandler$$$$getNextNavigable$$($DvtTagCloudAutomation$$, $DvtTagCloudStyleUtils$$, $DvtTagCloudItem$$) {
    $DvtTagCloudStyleUtils$$ = $DvtTagCloudStyleUtils$$.keyCode == $dvt$$16$$.KeyboardEvent.$RIGHT_ARROW$ || $DvtTagCloudStyleUtils$$.keyCode == $dvt$$16$$.KeyboardEvent.$DOWN_ARROW$ ? !0 : !1;
    $DvtTagCloudAutomation$$ = $dvt$$16$$.$ArrayUtils$.$getIndex$($DvtTagCloudItem$$, $DvtTagCloudAutomation$$) + ($DvtTagCloudStyleUtils$$ ? 1 : -1);
    return $DvtTagCloudAutomation$$ < $DvtTagCloudItem$$.length && 0 <= $DvtTagCloudAutomation$$ ? $DvtTagCloudItem$$[$DvtTagCloudAutomation$$] : null;
  };
  $dvt$$16$$.$Obj$.$createSubclass$(function() {
  }, $dvt$$16$$.$DropTarget$);
  $dvt$$16$$.$exportProperty$($dvt$$16$$, "TagCloud", $dvt$$16$$.$TagCloud$);
  $dvt$$16$$.$exportProperty$($dvt$$16$$.$TagCloud$, "newInstance", $dvt$$16$$.$TagCloud$.newInstance);
  $dvt$$16$$.$exportProperty$($dvt$$16$$.$TagCloud$.prototype, "render", $dvt$$16$$.$TagCloud$.prototype.$render$);
  $dvt$$16$$.$exportProperty$($dvt$$16$$.$TagCloud$.prototype, "getAutomation", $dvt$$16$$.$TagCloud$.prototype.$getAutomation$);
  $dvt$$16$$.$exportProperty$($dvt$$16$$.$TagCloud$.prototype, "highlight", $dvt$$16$$.$TagCloud$.prototype.$highlight$);
  $dvt$$16$$.$exportProperty$($dvt$$16$$.$TagCloud$.prototype, "select", $dvt$$16$$.$TagCloud$.prototype.select);
  $dvt$$16$$.$exportProperty$($DvtTagCloudAutomation$$.prototype, "getDomElementForSubId", $DvtTagCloudAutomation$$.prototype.$getDomElementForSubId$);
  $dvt$$16$$.$exportProperty$($DvtTagCloudAutomation$$.prototype, "getItem", $DvtTagCloudAutomation$$.prototype.getItem);
  $dvt$$16$$.$exportProperty$($DvtTagCloudAutomation$$.prototype, "getItemCount", $DvtTagCloudAutomation$$.prototype.$getItemCount$);
})(dvt);
